package com.gmei.up.utils

import scala.concurrent.Future
import com.redis.{ RedisClient, RedisClientPool }

object Redis {
  // TODO read from config file

  implicit val ec: scala.concurrent.ExecutionContext = scala.concurrent.ExecutionContext.global

  val pRc4 =
    new RedisClientPool("172.16.50.145", 6379, database = 0, secret = Some("XfkMCCdWDIU%ls$h"), timeout = 500)

  def save(contentF: Future[IndexedSeq[Content]], deviceId: String, contentType: String): Unit = {
    val key = s"streaming:candidate:${contentType}:device_id:${deviceId}"

    pRc4.withClient { client =>
      contentF.foreach { seq =>
        val ids = seq.map(c => c.id)
        if (ids.size > 0) {
          client.del(key)
          ids.foreach { id =>
            // println(id)
            client.rpush(key, id)
          }
          client.expire(key, 60 * 60 * 24 * 15)
        }
      }
    }
  }
}
